=== debian/changelog ===
libshark (3.0.11) oneiric; urgency=low
	
  * Added build-dependency on python-pyparsing
  * Added automatic building and installation of doxylink
  * Added build-dependency on graphviz.
  * Added automatic installation of sphinxcontrib-doxylink
  * Added installation of documentation.
  * Adjusted the section to science.
  * Added doxygen, texlive and python-sphinx to build dependencies.
  * Removed kernel function unit test.
  * Added cmake as build dependency.
  * Adjusted distro series in debian/changelog to oneiric.
  * Adjusted distro series in debian/changelog.
  * Initial release.

 -- Thomas Voß <thomas.voss@rub.de>  Wed, 09 Nov 2011 08:53:35 +0100
