=== debian/control ===
Source: libshark
Maintainer: Thomas Voß <thomas.voss@rub.de>
Section: science
Priority: optional
Standards-Version: 3.0.0
Build-Depends: graphviz, python-pip, doxygen, texlive-full, python-pyparsing, python-sphinx, cmake, libboost1.46-all-dev, debhelper (>= 7.3.8)
Homepage: http://shark-project.sourceforge.net

Package: libshark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Shark Machine Learning Library
 SHARK is a modular C++ library for the design and
 optimization of adaptive systems. It provides methods for linear and
 nonlinear optimization, in particular evolutionary and gradient-based
 algorithms, kernel-based learning algorithms and neural networks, and
 various other machine learning techniques. SHARK serves as a toolbox
 to support real world applications as well as research indifferent
 domains of computational intelligence and machine learning. The
 sources are compatible with the following platforms: Windows, Solaris,
 MacOS X, and Linux.
